package com.fp.persistence.pgeneral.menu;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;

import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENULEVELDESC*/
@Entity(name="TgeneMenuLevelDesc")
@Table(name="TGENEMENULEVELDESC")
public class TgeneMenuLevelDesc extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuLevelDesc
*/
@EmbeddedId
private TgeneMenuLevelDescKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion por idioma de la agrupacion del menu
*/
private String description;

/**Contructor por defecto*/
public TgeneMenuLevelDesc(){
}
/**Contructor de TgeneMenuLevelDesc
@param pPk Clave Primaria del entity
*/
public TgeneMenuLevelDesc(TgeneMenuLevelDescKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuLevelDesc
*/
public static TgeneMenuLevelDesc find(EntityManager pEntityManager,TgeneMenuLevelDescKey pKey) throws Exception{
    TgeneMenuLevelDesc obj = pEntityManager.find(TgeneMenuLevelDesc.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuLevelDesc
@return El objeto que referencia a la Clave primaria de TgeneMenuLevelDesc
*/
public TgeneMenuLevelDescKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuLevelDesc
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuLevelDesc
*/
public void setPk(TgeneMenuLevelDescKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuLevelDesc))return false;
    TgeneMenuLevelDesc that = (TgeneMenuLevelDesc) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuLevelDesc
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuLevelDesc
*/
public Object createInstance(){
 TgeneMenuLevelDesc instance=new TgeneMenuLevelDesc();	
 instance.setPk(new TgeneMenuLevelDescKey());
 return instance;
}
/**Clona la entidad TgeneMenuLevelDesc
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuLevelDesc p=(TgeneMenuLevelDesc)this.clone();
  p.setPk((TgeneMenuLevelDescKey)this.pk.cloneMe());
  return p;
}
	
	//METODOS MANUALES
	/** Sentencia que devuelve un registro de TgeneMenuLevelDesc. */
	private static final String JPQL_MENU_GRUP_DESC = "from TgeneMenuLevelDesc tmgd" + " where tmgd.pk.menucode = :menucode"
        + " and tmgd.pk.levelcode = :levelcode" + " and tmgd.pk.languagecode = :languagecode";
	/**
     * Metodo que entrega descripcion del primer nivel del menu.
     * 
     * @param pmenucode Codigo de menu.
     * @param pLevel Codigo de nivel.
     * @param planguagecode Codigo de lenguaje del usuario.
     * @return TgeneMenuLevelDesc
     * @throws Exception
     */
    public static TgeneMenuLevelDesc find(EntityManager pEntityManager, Integer pmenucode, Integer pLevel, String planguagecode) throws Exception {
        Query qry = pEntityManager.createQuery(TgeneMenuLevelDesc.JPQL_MENU_GRUP_DESC);
        qry.setParameter("menucode", pmenucode);
        qry.setParameter("levelcode", pLevel);
        qry.setParameter("languagecode", planguagecode);
        try {
        	return (TgeneMenuLevelDesc) qry.getSingleResult();
		} catch (NoResultException e) {
			return null;
		}
    }
}
